#!/usr/bin/env python
#coding=utf-8

from airflow.models import DAG
from airflow.operators.bash_operator import BashOperator
from airflow.operators.subdag_operator import SubDagOperator
from subdags.idl_subdag import idl_subdag
import datetime
from config import *

default_args = {
    'owner' : 'wdc',
    'depends_on_past' : False,
    'start_date' : datetime.datetime(2017, 01, 01),
    'email' : ['wdc@huojutech.com'],
    'email_on_failure' : False,
    'email_on_retry': False,
    # 'retries' : 3,
    # 'retry_delay': datetime.timedelta(minutes=1),
}

DAG_NAME = 'once_dag'

dag = DAG(
    dag_id=DAG_NAME,
    default_args=default_args,
    schedule_interval='@once',
)

# 初始阶段运行一次即可
once_history_ad_tv_station_mid_avg_ratings_denoising_stat = BashOperator(
    task_id='once_history_ad_tv_station_mid_avg_ratings_denoising_stat',
    bash_command='cd ' + SCRIPT_PATH + '; python once_history_ad_tv_station_mid_avg_ratings_denoising_stat.py',
    dag=dag,
)

once_history_ad_tv_station_mid_avg_ratings_stat = BashOperator(
    task_id='once_history_ad_tv_station_mid_avg_ratings_stat',
    bash_command='cd ' + SCRIPT_PATH + '; python once_history_ad_tv_station_mid_avg_ratings_stat.py',
    dag=dag,
)

once_history_ad_tv_station_mid_ratings_denoising_stat = BashOperator(
    task_id='once_history_ad_tv_station_mid_ratings_denoising_stat',
    bash_command='cd ' + SCRIPT_PATH + '; python once_history_ad_tv_station_mid_ratings_denoising_stat.py',
    dag=dag,
)

once_history_ad_tv_station_mid_ratings_index_denoising_stat = BashOperator(
    task_id='once_history_ad_tv_station_mid_ratings_index_denoising_stat',
    bash_command='cd ' + SCRIPT_PATH + '; python once_history_ad_tv_station_mid_ratings_index_denoising_stat.py',
    dag=dag,
)

once_history_ad_tv_station_mid_ratings_index_stat = BashOperator(
    task_id='once_history_ad_tv_station_mid_ratings_index_stat',
    bash_command='cd ' + SCRIPT_PATH + '; python once_history_ad_tv_station_mid_ratings_index_stat.py',
    dag=dag,
)

once_history_ad_tv_station_mid_ratings_stat = BashOperator(
    task_id='once_history_ad_tv_station_mid_ratings_stat',
    bash_command='cd ' + SCRIPT_PATH + '; python once_history_ad_tv_station_mid_ratings_stat.py',
    dag=dag,
)