#!/usr/bin/env python
#coding=utf-8

from airflow.models import DAG
from airflow.operators.bash_operator import BashOperator
from airflow.operators.subdag_operator import SubDagOperator
from subdags.idl_subdag import idl_subdag
import datetime
from config import *

default_args = {
    'owner' : 'wdc',
    'depends_on_past' : False,
    'start_date' : datetime.datetime(2017, 01, 01),
    'email' : ['wdc@huojutech.com'],
    'email_on_failure' : False,
    'email_on_retry': False,
    # 'retries' : 3,
    # 'retry_delay': datetime.timedelta(minutes=1),
}

DAG_NAME = 'recent_one_year_stat_dags'

dag = DAG(
    dag_id=DAG_NAME,
    default_args=default_args,
    schedule_interval='40 0 * * *',
)

# 最近一年数据分离
tmp_recent_year_ad_television_data = BashOperator(
    task_id='tmp_recent_year_ad_television_data',
    bash_command='cd ' + SCRIPT_PATH + '; python tmp_recent_year_ad_television_data.py',
    dag=dag,
)

# 近一年平均收视率、收视指数统计
tmp_ad_tv_station_stat = BashOperator(
    task_id='tmp_ad_tv_station_stat',
    bash_command='cd ' + SCRIPT_PATH + '; python tmp_ad_tv_station_stat.py',
    dag=dag,
)

idl_ad_tv_station_stat = BashOperator(
    task_id='idl_ad_tv_station_stat',
    bash_command='cd ' + SCRIPT_PATH + '; python idl_ad_tv_station_stat.py',
    dag=dag,
)